var termBlaster_SearchWindow;

function termBlasterOptionsObserver()
{
  this.register();
}
termBlasterOptionsObserver.prototype = {
  observe: function(subject, topic, data) {
    //TermBlaster.updateMenu();
  },

  register: function() {
    var observerService = Components.classes["@mozilla.org/observer-service;1"]
                          .getService(Components.interfaces.nsIObserverService);
    observerService.addObserver(this, "TermBlasterOptions_btnOkCommand", false);
  },

  unregister: function() {
    var observerService = Components.classes["@mozilla.org/observer-service;1"]
                          .getService(Components.interfaces.nsIObserverService);
    observerService.removeObserver(this, "TermBlasterOptions_btnOkCommand");
  }
};

var TermBlaster = {
  updateMenu: function() {
    TermBlasterPopulator.loadPopup('database', document.getElementById("termblaster-database-popup"));
    TermBlasterPopulator.loadPopup('quicklist', document.getElementById("termblaster-quicklist-popup"));
  },

  onUnLoad: function() {
    //this.observer.unregister();
  },

  onMenuItemCommand: function() {
    window.open("chrome://termblaster/content/options.xul",
      "termBlaster_settings", "chrome");
  },

  onLoad: function() {
    TermBlaster.updateMenu();

    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                                getService(Components.interfaces.nsIPrefBranch);
    if (!prefs.getBoolPref("extensions.termblaster.initiated")) {
      prefs.setBoolPref("extensions.termblaster.initiated", true);
      var m = "termBlaster Important Notice: (You will not see this message again)\n\n";
      m += "Due to a known bug, termBlaster menus will appear as expected in all windows.. except the first window.\n\n";
      m += "Enjoy!";
      alert(m);
    }

    document.getElementById("contentAreaContextMenu")
      .addEventListener("popupshowing", TermBlaster.onPopup, false);
  },

  onPopup: function() {
    var database_popup = document.getElementById("termblaster-database-popup");
    var database_menu = document.getElementById("termblaster-database-menu");
    var quicklist_popup = document.getElementById("termblaster-quicklist-popup");
    var quicklist_menu = document.getElementById("termblaster-quicklist-menu");
    var seperator = document.getElementById("termblaster-separator");
    var textSelected = gContextMenu.isTextSelected;

    database_menu.hidden = !database_popup.hasChildNodes() || !textSelected;
    quicklist_menu.hidden = !quicklist_popup.hasChildNodes() || !textSelected;

    seperator.hidden = (database_menu.hidden && quicklist_menu.hidden);
  }
};

function termBlaster_SearchSelected (sQuery) {
  var selection = document.commandDispatcher.focusedWindow.getSelection()
    .toString().replace(/^\s*|\s*$/g,"");

  if (selection.length < 1)
    return;

  sQuery = sQuery.replace('\$s', encodeURIComponent(selection));

  var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                                getService(Components.interfaces.nsIPrefBranch);

  if (prefs.getPrefType("extensions.termblaster.destination") != prefs.PREF_INT)
    return;

  switch (prefs.getIntPref("extensions.termblaster.destination")) {
    case 0:
      if (termBlaster_SearchWindow == null) {
        window.open(sQuery, 'termBlaster_Results');
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                 .getService(Components.interfaces.nsIWindowMediator);
        var newWindow = wm.getMostRecentWindow("navigator:browser");
        termBlaster_SearchWindow = newWindow.getBrowser();
      } else {
        termBlaster_SearchWindow.addTab(sQuery);
      }
    break;
    case 2:
      window.open(sQuery);
    break;
    case 3:
      getBrowser().loadURI(sQuery);
    break;
    default: getBrowser().addTab(sQuery);
  }
}
